/* titel: vis2.c; Darstellen nicht druckbarer Zeichen, (Version 2)   */

#include <stdio.h>
#include <ctype.h>

char *progname = "vis2";
main(int argc, char** argv) {
        FILE *fin, *fout, *efopen();
        if (argc != 3)
                fprintf(stderr,\
                      "Syntax: %s Quelldatei Zieldatei\n",progname), 
                exit(1);
        fin  = efopen(argv[1],"r");
        fout = efopen(argv[2],"w");
        vis(fin,fout);
        fclose(fin);
        fclose(fout);
}        
vis(FILE* in,FILE* out) {
        int c;
        while ( (c=getc(in)) != EOF )
                if (isprint(c)) putc(c, out);
                else fprintf(out,"\\0x%x", c);
}               
FILE *efopen(char* file,char* mode) {
     FILE *fp, *fopen();
     extern char *progname;
     if ( (fp = fopen(file, mode)) != NULL )
             return fp;
     fprintf(stderr, "%s: Datei %s kann im Modus %s nicht\
 geoeffnet werden\n", progname, file, mode );
     exit(1);
}


