/* titel: vis4.c; Darstellen nicht druckbarer Zeichen (Version 4), Schalter */

#include <stdio.h>
#include <ctype.h>
#include "files.c"  /* enthaelt efopen() */
char *progname = "vis4";
int ausgabe = 0;
main(int argc, char** argv){
       FILE *fin, *fout, *efopen();
        while ( argc > 1 && argv[1][0] == '-'){
	  switch (argv[1][1]){
	    case 'd': ausgabe = 1; break;
            default: fprintf(stderr, "%s:\
                                 unbekanntes Argument %s\n",progname,argv[1]);
                        exit(1);
          }
          argc--;  argv++;
        }                               
        if (argc < 2)
            fprintf(stderr,\
            "Syntax: %s [-opt [-opt...]] Quelldatei Zieldatei\n",progname), 
                exit(1);
        fin  = efopen(argv[1],"r");  fout = efopen(argv[2],"w");
        vis(fin,fout);
        fclose(fin); fclose(fout);
}        
vis(FILE* in, FILE* out){
        int c;
        while ( (c=getc(in)) != EOF )
                if (isprint(c)) putc(c, out);
                else if (ausgabe == 0) 
		        fprintf(out, "\\0x%x", c);
	        else    fprintf(out, "\\0d%d", c);
}               
