/* titel: Lerr.c, zum Testen von _fclose() in LFILE.c usw. */
               
#include "LFILE.c" /* enthaelt nun _fclose() */

#include <errno.h>

/* Es folgen auf die selbstdefinierten IO-Kanaele wirkende IO-Funktionen */
#include <stdarg.h> 
int fprintf(FILE *fp, char *fmt, ...) {
  char s[200], *p;
  va_list args;
  va_start(args, fmt);
  vsprintf(s, fmt, args);
  for (p = s ; *p; p++) {
    putc(*p, fp);
    if (*p == '\n')
      _fflush_(fp);
  }
  va_end(args);
  return p-s;
}
int printf(char *fmt, ...) {
  char s[200], *p;
  va_list args;
  va_start(args, fmt);
  vsprintf(s, fmt, args);
  for (p = s ; *p; p++) {
    putchar(*p);
    if (*p == '\n')
      _fflush_(stdout);
  }
  va_end(args);
  return p-s;
}
int gets(char *s) {
  int c, i=0;
  _fflush_(stdout); 
  if ( stdin->flag & _EOF )
    stdin->flag ^= _EOF;
  while ( (c=getchar()) != EOF && c != '\n')
    *s++ = c, i++;
  *s = 0;
  return i;
}

FILE *efopen(char*,char*);
FILE *fp = NULL;
char *progname = "Lerr.c";

main() {
  char name[40], mode[4], what[4];
  char syscall[80];
  while(1) {
    mode[0] = 0;
    printf("....filepointer = %d", fp);
    if (fp) 
      printf(", descriptor = %d",fp->fd);
    printf("\n");
    printf("....open/close/unlink (o/c/u): "); gets(what);
    if (what[0] == 'o') {
      printf("....Dateiname:                 "); gets(name);
      printf("....Modus:                     "); gets(mode);
      if (fp = efopen(name,mode)) {
	printf("......................................");
	printf("Datei %s ist offen (mode %s)\n", name, mode);
	switch (mode[0]) {
	  int cc;
	case 'r': 
	  printf("....Lesen aus Datei:\n");
	  while ( (cc = getc(fp)) != EOF)
	    putchar(cc);
	  break;
	case 'a':
	case 'w':
	  printf("....Schreiben in Datei,");
	  printf("case a/w: mode = %c\n",mode[0]);
	  while ( (cc = getchar()) != EOF )
	    putc(cc, fp);
	  break;
	default: ;
	}
      }
    }
    else if (what[0] == 'c') {
      _fclose(fp); 
      printf("......................................");
      printf("Datei %s ist geschlossen\n", name);
      fp = NULL;
    }
    else if (what[0] == 'u') {
      printf("....Dateiname:                 "); gets(name);
      unlink(name); 
      fp = NULL;
    }
    else 
      printf("....Keine zulaessige Eingabe.\n");
    if ( errno )
      perror("perror sagt");
    errno = 0;
    if (fp) 
      if ( (fp->flag | _ERR) == _ERR )
	fprintf(stderr,"....Fehler....\n");
    if ( (mode[0] != 'r') ) {
      sprintf(syscall,"cat %s", name);
      printf("....Dateiinhalt auf der Platte jetzt: \n");
      system(syscall ); 
      if (fp)
	printf("....Dateiinhalt nicht unbedingt vollstaendig, da\
 Datei %s offen (mode %s)\n", name, mode);
    }
  }
}
FILE *efopen(char* file,char* mode) {
  FILE *fp, *fopen();
  if ( (fp = fopen(file, mode)) != NULL )
    return fp;
  perror("efopen");
  fprintf(stdout, "%s:\
 Datei %s kann im Modus %s nicht geoeffnet werden.\n", progname, file, mode );
  return 0;
}
