/* titel: Lerr.c, zum Testen von _fclose() in LFILE.c usw. */
               
#include "LFILE.c"

#include <errno.h>
#include <assert.h> 

#include <stdarg.h>
int _fprintf(FILE *fp, char *fmt,...) {
  va_list args;
  va_start(args, fmt);
  vfprintf(fp, fmt, args);
  va_end(args);
  return 0;
}

FILE *efopen(char*,char*);
FILE *fp = NULL;
char *progname = "Lerr.c";

main() {
    char name[40], mode[20], what[3];
    char syscall[80];
    while(1) {
	_fprintf(stdout,"filepointer = %d", fp);
	_fflush_(stdout);
	if (fp) 
	  fprintf(stdout,", descriptor = %d\n",fp->fd);
	else 
	  fprintf(stdout,"\n");
	fprintf(stdout,"open/close/unlink (o/c/u): "); gets(what);
	switch( what[0]) {
	  case 'o': 
	    fprintf(stdout,"Dateiname: 	  "); gets(name);
	    fprintf(stdout,"Modus:     	  "); gets(mode);
	    fprintf(stdout,"Modus = %c\n",mode[0]);
	    fp = efopen(name,mode); 
	    switch (mode[0]) {
	      int cc;
	      case 'r': 
	      fprintf(stdout,"Lesen aus Datei:\n");
	         while ( (cc = getc(fp)) != EOF)
			putchar(cc);
	         _fflush_(stdout);
		 break;
	      case 'a':
	      case 'w':
	      fprintf(stdout,"Schreiben in Datei:\n");
	      fprintf(stdout,"case a/w: Modus = %c\n",mode[0]);
		 while ( (cc = getchar()) != EOF)
			putc(cc, fp);
	         _fflush_(fp);
		 break;
	      default: ;
	    }
	    break;
	  case 'c': 
	    _fclose(fp); 
	    fp = NULL;
	    break;
	  case 'u': 
	    fprintf(stdout,"Dateiname: 	  "); gets(name);
	    unlink(name); 
	    fp = NULL;
	    break;
	  default: break;
	}
	if ( errno ) 
	    perror("perror sagt");
	else
	    fprintf(stderr,"Kein Fehler....\n");
	sprintf(syscall,"ls -s %s", name);
	system( syscall );
    }
}
list_all_errors() {
    for (errno = 0; errno < 76; errno++){
	fprintf(stderr,"%d:", errno); 
	perror("");
    }
}
FILE *efopen(char* file,char* mode) {
     FILE *fp, *fopen();
     if ( (fp = fopen(file, mode)) != NULL )
             return fp;
     perror("efopen");
     fprintf(stdout, "%s:\
 Datei %s kann im Modus %s nicht geoeffnet werden\n", progname, file, mode );
     _fclose(stdout);
     exit(1);
}
