/* titel: getop.c, Teil von calc, UPN-Taschenrechner   */

#include <ctype.h>
#include "Lcalc.h"

int getop(char s[], int lim) {
    int     i, c;
    while ((c = my_getch()) == ' ' || c == '\t' || c == '\n');
    if (c != '.' && (c < '0' || c > '9'))
	return (c);
    s[0] = c;
    for (i = 1; (c = my_getch()) >= '0' && c <= '9'; i++)
	if (i < lim)
	    s[i] = c;
    if (c == '.') {
	if (i < lim)
	    s[i] = c;
	for (i++; (c = my_getch()) >= '0' && c <= '9'; i++)
	    if (i < lim)
		s[i] = c;
    }
    if (i < lim) {
	ungetch(c);
	s[i] = '\0';
	return (NUMBER);
    }
    else {
	while (c != '\n' && c != EOF)
	    c = getchar();
	s[lim - 1] = '\0';
	return (TOOBIG);
    }
}

/* -------------------------- Ende von getop.c -------------------------- */
