/* titel: Lsyscalls.h, io-Funktionen auf low level-Basis, gepuffert */

#define EOF -1
#define BUFSIZE 1024

int getchar(void) {
  static char buf[BUFSIZE];
  static char *bufp = buf;
  static n = 0;
  if (n == 0) {
    n = read(0, buf, sizeof buf);
    bufp = buf;
  }
  return ( --n >= 0 ) ? (unsigned char) *bufp++ : EOF ;
}
/* Pufferung von putchar. Man muss fuer die finale Ausgabe eine
Flush-Moeglichkeit vorsehen. Daher werden die Puffer-Variablen 
als static und als gemeinsam bekannt fuer beide Funktionen deklariert.*/

static char outbuf[BUFSIZE];
static char *outbufp = outbuf;
void putchar(char c) {
  if (outbufp - outbuf == BUFSIZE) {
    write(1, outbuf, sizeof outbuf);
    outbufp = outbuf;
  }
  *outbufp++ = c;
}
void flush() {
  write(1, outbuf, sizeof outbuf);
  outbufp = outbuf;
}

  
 

