/* titel: vis1.c; Darstellung nicht druckbarer Zeichen (Version 1)  
                  Kernighan - Pike, chapt. 6, p. 173                */
#include <stdio.h>
#include <ctype.h>
main(){
  int c;
  while ((c = getchar()) != EOF ) {
    if ( isprint(c) ) putchar(c);  /* isprint(c) ist != 0 
                                                fuer  0x20 <= c <= 0x7e */
    else printf("\\x%x", c);
  }
}               

