/* titel: stack.c, Teil von calc, UPN-Taschenrechner   */

#include "calc.h"

#define MAXVAL  100

int     sp = 0;
double  val[MAXVAL];
void loadstack(void) {
    FILE * fopen(), *fp;
    if ((fp = fopen(DATA, "r")) != NULL) {
	int     i;
	fscanf(fp, "%d", &sp);
	for (i = 0; i < sp; i++)
	    fscanf(fp, "%lf", val + i);
	fclose(fp);
    }
    else
	printf("Kein Datenfile calc.dat gefunden\n");
}
void writestack(void) {
    FILE * fopen(), *fp;
    if ((fp = fopen(DATA, "w")) != 0) {
	int     i;
	fprintf(fp, "%d ", sp);
	for (i = 0; i < sp; i++)
	    fprintf(fp, DFORM, val[i]);
	fclose(fp);
    }
    else
	printf("Kein Datenfile calc.dat geoeffnet\n");
}
void negate(void) {
    val[sp - 1] = -val[sp - 1];
}
void invers(void) {
    if (val[sp - 1])
	val[sp - 1] = 1.0 / val[sp - 1];
    else
	printf("Divisor 0\n");
}
void doppel(void) {
    int     i;
    if ((i = (int) getch()) >= '1' && i <= '9') {
	i = i - '0';
	val[sp] = val[sp - i];
	sp++;
    }
    else ungetch(i);
}
void exchange(void) {
    int     i;
    double  temp;
    if ((i = (int) getch()) >= '1' && i <= '9') {
	i = i - '0';
	temp = val[sp - 1];
	val[sp - 1] = val[sp - i];
	val[sp - i] = temp;
    }
    else ungetch(i);
}
void stack(void) {
    int     i;
    printf("\n");
    if (sp > 0)
	for (i = sp - 1; i >= 0; i--)
	    printf("st%2d:  ", sp - i), printf(FORM, val[i]);
    else
	printf("\nStack leer\n");
}
double  push(double f) {
    if      (sp < MAXVAL)
	        return (val[sp++] = f);
    else {
	printf("Error: Stack voll\n");
	clear();
	return 0;
    }
}
double  pop(void) {
    if     (sp > 0)
	        return (val[--sp]);
    else {
	printf("Error: Stack leer\n");
	clear();
	return(0);
    }
}
void clear(void) {
    sp = 0;
}

/* -------------------------- Ende von stack.c -------------------------- */
