/* titel: bits.c; gibt die Bit-Kodierung der numerischen Datentypen aus */

/* #define VAX_11   Auf Microvax muss dies definiert sein            */
/* #define SPARC    Auf einer Sun mit Sparc-Architektur              */
/* Auf einer DEC-Alpha oder einem IBM-PC soll keines definiert sein  */

#define bits(A, C) bt( (char *)&(A), sizeof( (A) ), (C) )
#include <stdio.h>

main() {      
       char c;  int i; long l;
       void bt(char [], int, char);    /* Funktionsprototyp */
       float f; double z;
       for(;;)
       {  printf("z: "); scanf("%lf", &z); printf("%lf\n", z);
          c = (char) z; printf("char:   "); bits(c,'i');
          i = (int)  z; printf("int:    "); bits(i,'i');
          l = (long) z; printf("long:   "); bits(l,'i');
          f = (float)z; printf("float:  "); bits(f,'f');
                        printf("double: "); bits(z,'f');
          printf("\n"); 
       }
}
void bt(char x[],int n,char t) {      	
       unsigned char c; int i;
#ifdef VAX_11   /* Bedingte Compilation: 
		Bei der Fliesskommainterpretation auf der Vax nimmt man
		besser die Bytes in aufsteigender Reihenfolge und 
		vertauscht dann noch die geraden mit den ungeraden Bytes. */
       if ( t == 'f')
	    for (i=0; i<n ;i++)
	    {   int k = ( i&1 ) ? -1:1;
		for( c = 128; c != 0; c>>=1)
		    putchar( ( c & x[i+k] ) ? '1':'0' );
		putchar(' '); 	
	    }
       else
#endif         
#ifdef SPARC
       for (i = 0; i < n; i++ )
#else
       for (i = n-1; i >= 0; i--) 
#endif
       {   for( c = 128; c != 0; c>>=1)
		putchar( ( c & x[i] ) ? '1':'0' );
            putchar(' ');
       }
       putchar('\n');
}
