/* titel: my_getch.c, getchar-Erweiterung mit erweiterter unget-Moeglichkeit */

#include <stdio.h>
#include <curses.h>

#define BUFSIZE  100
char    buf[BUFSIZE];  /* ungetch-Puffer */
int     bufp = 0;      /* naechste freie Puffer-Position */
int     my_getch(void) {
              return (bufp > 0) ? (int) buf[--bufp] : getch();
}
void ungetch(int c) {
    if (bufp > BUFSIZE)
	fprintf (stderr, "ungetch: Zu viele Zeichen\n");
    else
	buf[bufp++] = c;
}

/* -------------------------- Ende von getch.c -------------------------- */
